--
-- ProfiLua
-- Example #6
--
-- How to output a Lua table, including zeros, to a ProfiLab string.
--
-- (c) ASkr, www.askrprojects.net
--

gNumInputs  = 6
gNumOutputs = 2

InputNames  = {"Byte1","Byte2","Byte3","Byte4","Byte5","Byte6"}
OutputNames = {"$String","OV"}

function gInputName(channel)
	return InputNames[channel]
end

function gOutputName(channel)
	return OutputNames[channel]
end

function gSimStart(In)
	return {"",0}
end

function gSimStop(In)
end





------------------------------------------------------------------------------
-- Code2String
--
-- Converts a table to a string. Additionally, thise function replaces:
--   0x00 -> 0x10 0xff   -- code for zero
--   0x10 -> 0x10 0x10   -- code for 0x10
------------------------------------------------------------------------------
function Code2String(tab)
	local i
	local str = ""
	
	-- not that fast (due to ".."), but the string is not that long...
	for _,i in ipairs(tab) do
		if i == 0x10 then
			str = str..string.char(0x10)..string.char(0x10)
		elseif i == 0x00 then
			str = str..string.char(0x10)..string.char(0xff)
		else
			str = str..string.char(i)
		end
	end
	
	return str
	
end


------------------------------------------------------------------------------
-- gCalulate
--
--
------------------------------------------------------------------------------
function gCalculate(In)
	local overflow = gLOW
	local data = {}
	local str = ""
	local i

	for i=1,6 do
		if In[i] < 0 or In[i] > 255 then
			overflow = gHIGH
			data = {}
			break
		else
			data[i] = In[i]
		end
	end

	-- at this point, "data" is the table we would like to export via a ProfiLab string.
	if overflow == gLOW then
		str = Code2String(data)
	end

	
	return {str,overflow}
end

